/*
 * Copyright (c) 2008 Christian W. Guenther (christian@deckfour.org)
 * Copyright (c) 2013 F. Mannhardt (f.mannhardt@tue.nl)
 * 
 * LICENSE:
 * 
 * This code is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 3 of the License, or (at your option) any
 * later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */
package org.processmining.xeslite.external;

import java.util.Set;

import org.deckfour.xes.extension.XExtension;
import org.deckfour.xes.id.XID;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XTrace;
import org.deckfour.xes.model.XVisitor;

/**
 * @author F. Mannhardt
 * 
 */
public final class PumpEventImpl implements XEvent {

	private XAttributeMap attributes;

	public PumpEventImpl(XAttributeMap attributes) {
		this.attributes = attributes;
	}

	public XAttributeMap getAttributes() {
		return attributes;
	}

	public void setAttributes(XAttributeMap attributes) {
		this.attributes = attributes;
	}

	public boolean hasAttributes() {
		return !attributes.isEmpty();
	}

	public Set<XExtension> getExtensions() {
		throw new UnsupportedOperationException();
	}

	@Override
	public Object clone() {
		throw new UnsupportedOperationException();
	}

	@Override
	public boolean equals(Object o) {
		if (o instanceof PumpEventImpl) {
			return o == this;
		} else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return System.identityHashCode(this);
	}

	public XID getID() {
		throw new UnsupportedOperationException();
	}

	public void accept(XVisitor visitor, XTrace trace) {
		throw new UnsupportedOperationException();
	}

}